TRDmake_power_series := proc(p::polynom,d::extended_numeric,g::procedure)
local ps;
    ps := table();
    ps[POLY] := p;
    ps[DEG] := d;
    ps[GEN] := g;
    return TRDrename_power_series(ps);
end proc;

TRDrename_power_series := proc(ps::table)
local power_series;
    power_series := eval(ps);
    return(power_series);
end proc:

TRDone := proc()
    local homog_parts_of_one := proc(d::integer)
          if (d = 0) then return (1); else return (0); end if;
    end proc;
    TRDmake_power_series(1, 0, homog_parts_of_one);
end proc;

TRDzero := proc()
    local homog_parts_of_zero := proc(d::integer)
          return (0);
    end proc;
    TRDmake_power_series(0, 0, homog_parts_of_zero);
end proc;

TRDpoly := proc(p::polynom, R::table)
local homog_parts_of_poly := proc(d::integer)
        return TRDhomogeneous_part_of_polynomial(p, d);
    end proc;
    return TRDmake_power_series(p, max(0,degree(p)), homog_parts_of_poly);
end proc;

TRDhomogeneous_part_func := proc(g::procedure, R::table)
local p;
    p := g(0) + g(1);
    return TRDmake_power_series(p, 1, g);
end proc;

TRDdisplay := proc(ps::table)
    ps[POLY];
end proc;

TRDpower_series_coefficient := proc(ps::table, exponents::list)
   local d, i, c;
   d := foldl(`+`, op(exponents));
   if (d > ps[DEG]) then
      for i from (ps[DEG] + 1) to d do
             ps[POLY] := ps[POLY] + (ps[GEN])(i);
      end do;
   ps[DEG] := d;
   end if;
   c := TRD_polynomial_coefficient(ps[POLY], R, exponents);
   return (c);
end proc;

TRDgeometric_series := proc()
local homog_parts_of_geom_series := proc(d::integer)
      local vars, s, i, v;
      vars := R[variables];
      s := 0;
      for i from 1 to nops(vars) do
          v := vars[i];
          s := s + v;
      end do;
      return (s^d);
      end proc;
return TRDmake_power_series(1, 0, homog_parts_of_geom_series);
end proc;

TRDsum_of_all_monomials := proc()
local homog_parts_of_sum_of_all_monomials := proc(d::integer)
      local vars, univ_pols, i, e, v, big_pol, h;
      vars := R[variables];
      univ_pols := [];
      for i from 1 to nops(vars) do
          v := vars[i];
          univ_pols := [sum(v^e, e=0..d), op(univ_pols)];
      end do;
      big_pol := foldl(`*`,op(univ_pols));
      h := TRDhomogeneous_part_of_polynomial(big_pol, d);
      return (h);
      end proc;
return TRDmake_power_series(1, 0, homog_parts_of_sum_of_all_monomials);
end proc;
