read "powerseries.mpl":
PS := PowerSeries([X,Y]):
s1 := PS:-One:
s0 := PS:-Zero:
with(PS):

test_1 := proc()
    local s2, s3, s4, s5;
    PS:-ComputedTerms(PS:-Zero);
    s2 := PS:-PolynomialToPowerSeries(1 + X + Y + X^2 + Y^2);
    PS:-ComputedTerms(s2);
    s3 := PS:-Add(s1, s2);
    PS:-ComputedTerms(s3);
    s4 := PS:-Add(s2, s2);
   if (PS:-ComputedTerms(s4) - (2*X^2 + 2*Y^2 + 2*X + 2*Y +2)) <> 0 then
         error "Wrong result";
    end if;
    PS:-ComputedTerms(s4);
    s5 := PS:-Subtract(s2, s2);
    if PS:-ComputedTerms(s5) <> 0 then error "Wrong result" end if;
    print ("Passed!");
end proc:

test_2 := proc()
    local s6, g;
    s6 := PS:-SumOfALLMonomials;
    PS:-ComputedTerms(s6);
    g := PS:-HomogeneousPartFunction(s6);
    PS:-Coefficient(s6,[1,1]);
    PS:-ComputedTerms(s6);
    PS:-HomegeneousPart(s6, 2);
    if (PS:-HomegeneousPart(s6, 2) <> (X^2  + X * Y + Y^2))then
         error "Wrong result";
    end if;
    PS:-ComputedTerms(s6);
    PS:-HomegeneousPart(s6, 1);
    if (PS:-HomegeneousPart(s6, 1) <> (X + Y) )then
         error "Wrong result";
    end if;
    PS:-ComputedTerms(s6);
    PS:-HomegeneousPart(s6, 10);
    PS:-ComputedTerms(s6);
    print ("Passed!");
end proc:

test_3 := proc()
    local s2, s7, g, h0, h1, h2, h3, h4, h5;
    s2 := PS:-PolynomialToPowerSeries(1 + X + Y + X^2 + Y^2);
    PS:-ComputedTerms(s2);
    s7 := PS:-Multiply(s2, s2);
    g := PS:-HomogeneousPartFunction(s7);
    h0 := g(0);
    h1 := g(1);
    h2:= g(2);
    h3 := g(3);
    h4 := g(4);
    h5 := g(5);
    if (expand(h0 + h1 + h2 + h3 + h4 + h5 - (1 + X + Y + X^2 + Y^2)^2) <> 0 ) then
         error "Wrong result";
    end if;
    PS:-TRDtruncate_polynomial(h0 + h1 + h2, 2);
    PS:-TRDtruncate_polynomial(h0 + h1 + h2, 1);
    PS:-ComputedTerms(s7);
    PS:-HomegeneousPart(s7,2);
    PS:-ComputedTerms(s7);
    PS:-HomegeneousPart(s7,3);
    PS:-ComputedTerms(s7);
    PS:-HomegeneousPart(s7,4);
    PS:-ComputedTerms(s7);
    PS:-HomegeneousPart(s7,5);
    PS:-ComputedTerms(s7);
    print ("Passed!");
end proc:

test_4 := proc()
    local s8, s9, s10;
    s8 := PS:-PolynomialToPowerSeries(1 - X - Y);
    s9 := PS:-ExactQuotient(s1, s8);
    PS:-ComputedTerms(s9);
    PS:-HomegeneousPart(s9,2);
    PS:-ComputedTerms(s9);
    PS:-HomegeneousPart(s9,3);
    PS:-ComputedTerms(s9);
    PS:-HomegeneousPart(s9,20);
    PS:-ComputedTerms(s9);
    s10 := PS:-Multiply(s8, s9);
    PS:-HomegeneousPart(s10,20);
    if (expand (PS:-HomegeneousPart(s10,20)) <> 0) then
         error "Wrong result";
    end if;
    PS:-ComputedTerms(s10);
print ("Passed!");
end proc:

test_5 := proc()
    local f, h, g, p, d;
    f := s1;
    op(f);
    h := PS:-GeometricSeries;
    op(h);
    g := PS:-ExactQuotient(f, h);
    op(g);
    p := PS:-Multiply(h, g);
    op(p);
    if (expand(PS:-HomegeneousPart(p,0)) <> 1) then
        error "Wrong result";
    end if;
    for d from 1 to 10 do
        if (expand(PS:-HomegeneousPart(p,d)) <> 0) then
            error "Wrong result";
        end if;
    end do;
    print ("Passed!");
end proc:

test_6 := proc()
    local f, h, g, p, d;
    f := s1;
    op(f);
    h := PS:-SumOfALLMonomials;
    op(h);
    g := PS:-ExactQuotient(f, h);
    op(g);
    p := PS:-Multiply(h, g);
    op(p);
    if (expand(PS:-HomegeneousPart(p,0)) <> 1) then
        error "Wrong result";
    end if;
    for d from 1 to 10 do
        if (expand(PS:-HomegeneousPart(p,d)) <> 0) then
            error "Wrong result";
        end if;
    end do;
    print ("Passed!");
end proc:
