One := TRDone();

Zero := TRDzero();

PolynomialToPowerSeries := proc(f::polynom)
    return TRDpoly(f, R);
end;

Coefficient := proc(s::table, exponents::list)
    TRDpower_series_coefficient(s, exponents);
end proc;

HomogeneousPartFunctionToPowerSeries := proc(g::procedure)
    return TRDhomogeneous_part_func(g, R);
end;

GeometricSeries := TRDgeometric_series();

SumOfALLMonomials := TRDsum_of_all_monomials();

ComputedTerms := proc(ps::table)
    return TRDdisplay(ps);
end proc;

HomogeneousPartFunction := proc(ps::table)
    return (ps[GEN]);
end proc;

Add := proc(s1::table, s2::table)
    TRDsum(s1, s2);
end proc;

Subtract := proc(s1::table, s2::table)
    TRDsub(s1, s2);
end proc;

Multiply := proc(s1::table, s2::table)
    TRDproduct(s1, s2);
end proc;

HomegeneousPart := proc(s::table, d::integer)
    TRDhomogeneous_part(s,d);
end proc;

PolynomialPart := proc(s::table, d::integer)
    TRDpolynomial_part(s,d);
end proc;

ExactQuotient := proc(f::table, h::table)
    TRDexact_quotient(f, h);
end proc;

IsUnit := proc(f::table)
     return evalb(HomegeneousPart(f,0) <> 0);
end proc;

Inverse := proc(f::table)
     if IsUnit(f) then
         return ExactQuotient(One, f);
     else
         error "Not invertible";
     end if;
end proc;
