TRDmake_upops_from_polynomial := proc(f::polynom)
    local d, i, a;
    d := degree(f,Y);
    a := Array([seq(PS:-Zero,i=0..d)]);
    for i from 0 to d do
        a[i+1] := PS:-PolynomialToPowerSeries(coeff(f,Y,i));
    end do;
    return TRDmake_upops_from_array(a);
end;

TRDmake_upops_from_array := proc(a::Array)
local pol, i, upops;
    pol := 0;
    for i from 1 to ArrayNumElems(a) do
        pol := pol + PS:-ComputedTerms(a[i]) * Y^(i-1);
    end do;
    upops := table();
    upops[DATA] := a;
    upops[DEG] := ArrayNumElems(a)  - 1;
    upops[POLY] := pol;
    return TRDrename_upops(upops);
end proc;

TRDmake_upops_from_list := proc(l::list)
local a, i;
    a := Array([seq(PS:-PolynomialToPowerSeries(l[i]),i=1..nops(l))]);
    return TRDmake_upops_from_array(a);
end proc;

TRDrename_upops := proc(t::table)
local polynomial_over_power_series;
    polynomial_over_power_series := eval(t);
    return(polynomial_over_power_series);
end proc:

TRDone := proc()
    TRDmake_upops_from_polynomial(1);
end proc;

TRDzero := proc()
    TRDmake_upops_from_polynomial(0);
end proc;

TRDdisplay := proc(upops::table)
    upops[POLY];
end proc;

TRDdegree := proc(upops::table)
    upops[DEG];
end proc;

TRDdata := proc(upops::table)
    upops[DATA];
end proc;
