TRD_polynomial_coefficient := proc(p::polynom, R::table, exponents::list)
    local vars, c, i;
    vars := R[variables];
    if nops(vars) <> nops(exponents) then
            error "Exponent vector size is wrong";
    end if;
    c := coeff(p, vars[1], exponents[1]);
    for i from 2 to nops(vars) do
        c := coeff(c, vars[i], exponents[i]);
    end do;
    return(c);
end proc;

TRDterm := proc(c,R::table,exponents::list)
local t, i;
    if (c = 0) then return(0); end if;
    t := c;
    for i from 1 to nops(R[variables]) do
        t := t * (vars[i]) ^ (exponents[i]);
    end do;
    return (t);
end proc;

TRDterms := proc(pol::polynom)
      local new_pol;
      if not type(pol,polynom) then
         error "Invalid input";
      end if;
      new_pol := expand(pol);
      if (type(new_pol, `*`) or type(new_pol, `^`)) then
         return ([new_pol])
      else
         return ([op(new_pol)])
      end if;
end proc:

TRDhomogeneous_part_of_polynomial := proc(p::polynom, d::integer)
     local terms, h, t;
     terms := TRDterms(p);
     h := 0;
     for t in terms do
         if (degree(t) = d) then
             h := h + t;
         end if;
     end do;
     return (h);
end proc;

TRDtruncate_polynomial := proc(p::polynom, d::integer)
     local terms, h, t;
     terms := TRDterms(p);
     h := 0;
     for t in terms do
         if (degree(t) <= d) then
             h := h + t;
         end if;
     end do;
     return (h);
end proc;
